/*
 * This plugin adds a new rule to filter style content.
 * According to new rule all css styles which targeting body tag will be
 * automatically removed.
 */
define("ckeditor/plugins/epfilterstyle/plugin", [
    "jquery",
    "ckeditor/ckeditor"
    ], function ($, CKEDITOR) {

    // Keeps track of changes to the content and fires a "change" event
    CKEDITOR.plugins.add( 'epfilterstyle', {
        init : function( editor ) {
            editor.dataProcessor.dataFilter.addRules({
                elements: {
                    style: function(element) {

                        if (typeof element.children[0] != 'undefined') {
                            var filteredStyle = element.children[0].value.replace(/body.*{[\w\W]*?}/gi,'');
                            element.children[0].value = filteredStyle;
                        }
                    }
                }
            });
        }
    } );

    return CKEDITOR;
});